s         ::=  ws grammar ws                  => "gram"
ws       !::=  w**
grammar   ::=  r $$ ws => "grammar"
r         ::=  word  ^"::=" alternatives /ws
            |  word ^"!::=" alternatives /ws

alternatives  ::=  equiAlt   $$ (ws ">" ws)
equiAlt       ::=  conjuncts $$ (ws "|" ws)          => "alternatives"

sequence    ::= Es
              > Es ws ^"/" e
Es          ::= e+
es          ::= e %% ws

ss ::= es | es ^"/" e /ws

conjuncts   ::=  rewrite
              |  rewrite ^"&"  e%%ws   /ws
              |  rewrite ^"&~" e%%ws   /ws

rewrite  ::=  sequence                  /ws        => "rewrite"
           |  sequence ^"=>" word       /ws
           |  sequence ^"=>" quoted     /ws
           |  sequence  "=>" "()"       /ws        => "wrap"

ec       ::= [~\-\]\\\~]
           | escaped

range    ::= ec          => "range0"
           | ec ^"-" ec  => "range1"

e        ::= word                             => "nonTerminalY"
           |    [(][)] => "epsilon"
           |    ^"{" alternatives "}"   /ws
           |     "["  ranges "]"        => "range"
           |     "[~" ranges "]"        => "rangex"
           |  e ^"%%" e                 /ws
           |  e ^"$$" e                 /ws
           |  e ^"?"                    /ws
           |  e ^"~/~"                  /ws

           |  e ^"-"  e                 /ws

           |    ^"!" e                  /ws
           |     "^" quoted             /ws => "care"
           |    ^"`" e                  /ws
           |  e ^"#"                    /ws
           |  quoted                        => "literal"

           |  (e ws ^"**" > e ws ^"*")
           |  (e ws ^"++" > e ws ^"+")

           |     "(" word ^")"          /ws
           >    ^"(" alternatives ")"   /ws

ranges ::= range*

w       !::= " "
           | "//" [~\n]* "\n"
           | "\n"
           | "\r"
an       ::= [a-zA-Z0-9_]
word     ::= an++                           => "sify"
quoted   ::= "\"" ([~\"\\] | escaped)* "\"" => "sify"
escaped  ::= "\\n" => "\n"
           | "\\r" => "\r"
           | "\\" [~nr]


